#
# $Id: $
#

# Table: 'phpbb_kniffel_highscore'
CREATE TABLE phpbb_kniffel_highscore (
	nr int(11) UNSIGNED NOT NULL auto_increment,
	userid int(11) UNSIGNED DEFAULT '0' NOT NULL,
	monat tinyint(1) UNSIGNED DEFAULT '0' NOT NULL,
	jahr smallint(4) UNSIGNED DEFAULT '0' NOT NULL,
	score_date int(11) UNSIGNED DEFAULT '0' NOT NULL,
	points int(11) UNSIGNED DEFAULT '0' NOT NULL,
	games int(11) UNSIGNED DEFAULT '1' NOT NULL,
	score_array blob NOT NULL,
	PRIMARY KEY (nr),
	KEY monat (points,score_date),
	KEY jahr (jahr)
);


# Table: 'phpbb_kniffel_wurf'
CREATE TABLE phpbb_kniffel_wurf (
	userid int(11) UNSIGNED DEFAULT '0' NOT NULL,
	einer binary(6) DEFAULT '0' NOT NULL,
	zweier binary(6) DEFAULT '0' NOT NULL,
	dreier binary(6) DEFAULT '0' NOT NULL,
	vierer binary(6) DEFAULT '0' NOT NULL,
	funfer binary(6) DEFAULT '0' NOT NULL,
	sechser binary(6) DEFAULT '0' NOT NULL,
	dpasch binary(6) DEFAULT '0' NOT NULL,
	vpasch binary(6) DEFAULT '0' NOT NULL,
	fpasch binary(6) DEFAULT '0' NOT NULL,
	dopasch binary(6) DEFAULT '0' NOT NULL,
	trpasch binary(6) DEFAULT '0' NOT NULL,
	crpasch binary(6) DEFAULT '0' NOT NULL,
	gpasch binary(6) DEFAULT '0' NOT NULL,
	upasch binary(6) DEFAULT '0' NOT NULL,
	fullh binary(6) DEFAULT '0' NOT NULL,
	kstra binary(6) DEFAULT '0' NOT NULL,
	gstra binary(6) DEFAULT '0' NOT NULL,
	allee binary(6) DEFAULT '0' NOT NULL,
	kniffel binary(6) DEFAULT '0' NOT NULL,
	chance binary(6) DEFAULT '0' NOT NULL,
	PRIMARY KEY (userid)
);


# Table: 'phpbb_kniffel_user'
CREATE TABLE phpbb_kniffel_user (
	userid int(11) UNSIGNED DEFAULT '0' NOT NULL,
	wurf tinyint(1) UNSIGNED DEFAULT '0' NOT NULL,
	wurfel1 tinyint(1) UNSIGNED DEFAULT '0' NOT NULL,
	wurfel2 tinyint(1) UNSIGNED DEFAULT '0' NOT NULL,
	wurfel3 tinyint(1) UNSIGNED DEFAULT '0' NOT NULL,
	wurfel4 tinyint(1) UNSIGNED DEFAULT '0' NOT NULL,
	wurfel5 tinyint(1) UNSIGNED DEFAULT '0' NOT NULL,
	wurfel6 tinyint(1) UNSIGNED DEFAULT '0' NOT NULL,
	zaehler tinyint(1) UNSIGNED DEFAULT '0' NOT NULL,
	einer tinyint(1) UNSIGNED DEFAULT '99' NOT NULL,
	zweier tinyint(1) UNSIGNED DEFAULT '99' NOT NULL,
	dreier tinyint(1) UNSIGNED DEFAULT '99' NOT NULL,
	vierer tinyint(1) UNSIGNED DEFAULT '99' NOT NULL,
	funfer tinyint(1) UNSIGNED DEFAULT '99' NOT NULL,
	sechser tinyint(1) UNSIGNED DEFAULT '99' NOT NULL,
	dpasch tinyint(1) UNSIGNED DEFAULT '99' NOT NULL,
	vpasch tinyint(1) UNSIGNED DEFAULT '99' NOT NULL,
	fpasch tinyint(1) UNSIGNED DEFAULT '99' NOT NULL,
	dopasch tinyint(1) UNSIGNED DEFAULT '99' NOT NULL,
	trpasch tinyint(1) UNSIGNED DEFAULT '99' NOT NULL,
	crpasch tinyint(1) UNSIGNED DEFAULT '99' NOT NULL,
	gpasch tinyint(1) UNSIGNED DEFAULT '99' NOT NULL,
	upasch tinyint(1) UNSIGNED DEFAULT '99' NOT NULL,
	fullh tinyint(1) UNSIGNED DEFAULT '99' NOT NULL,
	kstra tinyint(1) UNSIGNED DEFAULT '99' NOT NULL,
	gstra tinyint(1) UNSIGNED DEFAULT '99' NOT NULL,
	allee tinyint(1) UNSIGNED DEFAULT '99' NOT NULL,
	kniffel tinyint(1) UNSIGNED DEFAULT '99' NOT NULL,
	chance tinyint(1) UNSIGNED DEFAULT '99' NOT NULL,
	bonus tinyint(1) UNSIGNED DEFAULT '0' NOT NULL,
	zsumm1 smallint(4) UNSIGNED DEFAULT '0' NOT NULL,
	zsumm2 smallint(4) UNSIGNED DEFAULT '0' NOT NULL,
	games int(11) UNSIGNED DEFAULT '1' NOT NULL,
	c1 tinyint(1) UNSIGNED DEFAULT '0' NOT NULL,
	c2 tinyint(1) UNSIGNED DEFAULT '0' NOT NULL,
	c3 tinyint(1) UNSIGNED DEFAULT '0' NOT NULL,
	c4 tinyint(1) UNSIGNED DEFAULT '0' NOT NULL,
	c5 tinyint(1) UNSIGNED DEFAULT '0' NOT NULL,
	c6 tinyint(1) UNSIGNED DEFAULT '0' NOT NULL,
	PRIMARY KEY (userid)
);


