<?php
/**
*
* @package phpbb3-SuperKniffel
* @version 1.2.0
* @author 2009 Bierhasser http://www.phpbb.de/community/memberlist.php?mode=viewprofile&u=3383
* @note only use for Install and Update MOD
* @copyright (c) 2009
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* DO NOT CHANGE
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

if (empty($lang) || !is_array($lang))
{
	$lang = array();
}

// DEVELOPERS PLEASE NOTE
//
// All language files should use UTF-8 as their encoding and the files must not contain a BOM.
//
// Placeholders can now contain order information, e.g. instead of
// 'Page %s of %s' you can (and should) write 'Page %1$s of %2$s', this allows
// translators to re-order the output of data while ensuring it remains correct
//
// You do not need this where single placeholders are used, e.g. 'Message %d' is fine
// equally where a string contains only two placeholders which are used to wrap text
// in a url you again do not need to specify an order e.g., 'Click %sHERE%s' is fine

$lang = array_merge($lang, array(
	// Install
	'TITLE'			=> 'Installation / Update %s',
	'WELCOME'			=> 'Willkommen zur Installation / Update ',
	'WELCOME_NOTE'		=> 'Bitte vergewisser dich das Du ein aktuelles Backup Deiner <b>Dateien</b> und Deiner <b>Datenbank</b> hast bevor du weiter machst!',
	'WARNING'			=> 'Warnung / Meldung',
	'MOD_SUPPORT'		=> 'http://a-y-c-e.de/viewtopic.php?f=19&amp;t=39595',
	'MOD_WRITER'		=> 'Bierhasser',
	'MENU'			=> 'Intro',
	'UPD_VERSION'		=> 'Update Version von %s nach %s',
	'INSTALL'			=> 'Installation',
	'INS_MENU'			=> 'Installations-Menü',
	'INS_NOTE'			=> 'Willkommen zur Installation von %s<br />Der Autor übernimmt keine Hafftung für etwaige Schäden an der Datenbank.<br />Dieser MOD verändert keine bestehenden Tabellen. Es werden 3 neue Tabellen installiert.',
	'NEED_FOUNDER'		=> 'Diese Aktion kann nur ein Gründer ausführen!',
	'NOTE_10x'			=> 'Highscore muss umgewandelt werden. Es darf sich nur ein Eintrag pro Monat und User in der Tabelle befinden.<br />Sollte das Update Fehlschlagen, Supper Kniffel Deinstallieren und neu Installieren. Alle Gespeicherten Spielstände gehen hierdurch verloren.<br />Anzahl Spiele, bis ein Highsore Eingetragen wurde werden geloggt.<br />Statistik fertig gestellt.<br />Schabernack Funktion integriert.',
	'NOTE_110'			=> 'Mod im Debugmodus berarbeitet.<br />Kleinere Code Änderungen.<br />Keine Veränderung in der Datenbank, Der Installer kann hier beendet werden.',
	'NOTE_INST'			=> 'Super Kniffel Installieren?',
	'NOTE_UPD'			=> 'Upate von Super Kniffel ausführen?',
	'INS_SUCCESS'		=> 'Installation von %s war erfolgreich',
	'INS_SUCC_NOTE'		=> 'Bitte entferne den Ordner %s und leere den Cache deines Forums nach dem du die Templates editiert hast!',
	'UPD_MENUE'			=> 'Update-Menü',
	'UPD_SUCCESS'		=> 'Update von %s nach %s war erfolgreich',
	'UPD_SUCC_NOTE'		=> 'Bitte entferne den Ordner %s und leere den Cache deines Forums nach dem du die aktuellen Templates installiert hast!',
	'REM_MENUE'			=> 'Entfernen-Menü',
	'REM_SHURE'			=> 'Bist du sicher das du Super Kniffel entfernen möchtest?',
	'REM_NOTE'			=> 'Entferne alle Dateien von Super Kniffel.',
	'REM_SUCCESS'		=> 'Super kniffel wurde erfolgreich entfernt.',
	'NOTE_REM'			=> 'Super Kniffel entfernen',
	'ERR_MAIN'			=> 'Installation / Update wurde wegen folgendem Fehler abgebrochen.',
	'ERR_HIGSCORE_TABLE'	=> 'In der <b>includes/constants.php</b> fehlt der Eintrag <b>define(\'KNIFFEL_HIGSCORE_TABLE\', $table_prefix . \'kniffel_highscore\');</b>',
	'ERR_USER_TABLE'		=> 'In der <b>includes/constants.php</b> fehlt der Eintrag <b>define(\'KNIFFEL_USER_TABLE\', $table_prefix . \'kniffel_user\');</b>',
	'ERR_WURF_TABLE'		=> 'In der <b>includes/constants.php</b> fehlt der Eintrag <b>define(\'KNIFFEL_WURF_TABLE\', $table_prefix . \'kniffel_wurf\');</b>',
	'ERR_TB_EXISTS'		=> 'Die Tabelle %s existiert! Super Kniffel ist schon installiert!',
	'ERR_TB_NOT_EXISTS'	=> 'Es konnten nicht alle Tabellen für Super Kniffel gefunden werden!<br />Überprüfe deine Installation.',
	'ERR_UNGOWN_UPD'		=> 'Die Update Funktion wurde mit einem ungültigen parameter aufgerufen.',
));


?>