<?php
/**
*
* @author Super - Kniffel Smoker ( www.smokers-board.de )
* @author based on Super - Kniffel Bierhasser http://www.phpbb.de/community/memberlist.php?mode=viewprofile&u=3383
*
* @package phpbb3-SuperKniffel
* @version 1.2.0
* @copyright (c) 2009
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

define('IN_PHPBB', true);
$phpbb_root_path = './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);


$user->session_begin();
$auth->acl($user->data);
// Language
$user->setup('mods/lang_superkniffel');


/*
* Inhaltsbereich
*/


if (!$user->data['is_registered'])
{
	if ($user->data['is_bot'])
	{
		redirect(append_sid("{$phpbb_root_path}index.$phpEx"));
	}
	login_box('', $user->lang['LOGIN_INFO']);
}



if (!file_exists($phpbb_root_path . 'includes/functions_superkniffel.' . $phpEx))
{
	exit;
}
include($phpbb_root_path . 'includes/functions_superkniffel.' . $phpEx);

// Start switching the mode...
$mode = request_var('mode', 'play');
// Spiel resetten
$neu = (int) request_var('neu', 0);

$mode = ($neu == 1) ? 'play' : $mode;
// Hold
$hold = request_var('check', array(0));

// Auto refresh sec
$refreshtime = 2;
$uid = $user->data['user_id'];
$anzwurf = 0;
$message = $CONF = $vergleich = $result = $s_hidden_fields = array();
$monat = date("n");
$jahr = date("Y");

$debug = $is_admin = false;
if (file_exists($phpbb_root_path . 'includes/conf_superkniffel.' . $phpEx))
{
	include($phpbb_root_path . 'includes/conf_superkniffel.' . $phpEx);
}

$result['games'] = 0;
if ($_SID)
{
	$s_hidden_fields['sid'] = $_SID;
}
	if ($auth->acl_get('a_') == 1)
	{
		$is_admin = true;
		$template->assign_vars(array(
			'S_ADMIN_LINK'	=> append_sid("{$phpbb_root_path}superkniffel.$phpEx", 'mode=config'),
		));
	}

	$monat_name = array(
		1	=> 'January',
		2	=> 'February',
		3	=> 'March',
		4	=> 'April',
		5	=> 'May',
		6	=> 'June',
		7	=> 'July',
		8	=> 'August',
		9	=> 'September',
		10	=> 'October',
		11	=> 'November',
		12	=> 'December'
	);
	// Wird auf allen Seiten benötigt auser in $mode == 'highscore', 'des', 'details', 'config'
	if ( !in_array($mode, array('highscore', 'des', 'details', 'config')) )
	{
		$tmp = kniffel_info($uid);
		$result = $tmp[0];
		$ergebnis = $tmp[1];
		unset($tmp);
		if ( $result['userid'] == $uid && $neu == 1)
		{
			$result['games'] += 1;
			$sql = 'DELETE FROM ' . KNIFFEL_USER_TABLE . ' WHERE userid = '.$uid;
			$db->sql_query($sql);
			$result['userid'] = false;
		}
		if ( $ergebnis['userid'] == $uid && $neu == 1)
		{
			$sql = 'DELETE FROM ' . KNIFFEL_WURF_TABLE . ' WHERE userid = '.$uid;
			$db->sql_query($sql);
			$ergebnis['userid'] = false;
		}
		if ( !$result['userid'] == $uid )
		{
			$result['games'] = ($result['games'] < 1) ? 1 : $result['games'];
			$sql = 'INSERT INTO ' . KNIFFEL_USER_TABLE . " (userid, games) VALUES ('$uid', '".(int) $result['games']."')";
			$db->sql_query($sql);
			$neu = 1;
		}
		if ( !$ergebnis['userid'] == $uid )
		{
			$sql = 'INSERT INTO ' . KNIFFEL_WURF_TABLE . " (userid) VALUES ('$uid')";
			$db->sql_query($sql);
			$neu = 1;
		}
		if ($neu == 1)
		{
			$tmp = kniffel_info($uid);
			$result = $tmp[0];
			$ergebnis = $tmp[1];
			unset($tmp);
		}
		$anzwurf = (int) $result['wurf'];
		$restwurf = (3 - $anzwurf);
	}

	switch($mode)
	{
		case 'play':
			$page_title = $user->lang['PLAY'];

			// altes Spiel fertig oder kein Spiel?
			$neu = ($result['zaehler'] == 0 && $anzwurf == 0) ? 1 : $neu;
			$schabernack = false;

			if ($neu == 1)
			{
				$message[] = $user->lang['FIRST_STRIKE'];
			}

			if ($neu == 0)
			{
				for ($i =0; $i < 6; $i++)
				{
					$a = $i + 1;
					$wurfel[$i] = $result['wurfel'.$a];
					$checked[$i] = $result['c'.$a];
					if ($result['wurfel'.$a] == 15)
					{
						// Vom Tisch gefallen
						if ($CONF['schaber_vt'] == 1)
						{
							$checked[$i] = 1;
							$message[] = $user->lang['ERROR_VOM_TISCH'];
							$anzwurf = 3;
							if ($result['wurf'] < $anzwurf)
							{
								$sql = 'UPDATE ' . KNIFFEL_USER_TABLE . " SET wurf='$anzwurf' WHERE userid = '$uid'";
								$db->sql_query($sql);
							}
							$schabernack = true;
						}
						else
						{
							// Schabernack Würfel vom Tisch ist ausgeschalten
							$tmp = rand_wuerfel(1,6);
							$sql = 'UPDATE ' . KNIFFEL_USER_TABLE . " SET wurfel".$a."='".$tmp."' WHERE userid = '$uid'";
							$db->sql_query($sql);
						}
					}
					if ($result['wurfel'.$a] == 20)
					{
						if ($CONF['schaber_tr'] == 1)
						{
							// Turm nochmal
							$checked[$i] = 0;
							$message[] = $user->lang['ERROR_TURM'];
							$schabernack = true;
						}
						else
						{
							// Schabernack Würfel Stapel ist ausgeschalten
							$tmp = rand_wuerfel(1,6);
							$sql = 'UPDATE ' . KNIFFEL_USER_TABLE . " SET wurfel".$a."='".$tmp."' WHERE userid = '$uid'";
							$db->sql_query($sql);
						}
					}
				}
				$do_hold = ($restwurf > 0 && $anzwurf > 0) ? do_hold($checked) : false;
				wgrafik($wurfel);

				$button = ($restwurf == 1) ? $user->lang['RESTWURF'] : sprintf($user->lang['RESTWURFE'], $restwurf);
				if ($result['wurf'] == 0)
				{
					$button = $user->lang['NEXT_STRIKE'];
				}
				if (!$schabernack && $result['wurf'] == 3)
				{
					$message[] = $user->lang['LAST_STRIKE'];
				}
			}

			$s_hidden_fields['mode'] = 'wurf';

			$higscore = simple_hiscore();
			fill_ergebniss($result, $ergebnis);

			$template->assign_vars(array(
				'S_PLAY_KNIFFEL'	=> true,
				'S_WUERFEL'		=> ( $result['wurf'] == 0 ) ? false : true,
				'S_KNOBELBECHER'	=> ( $anzwurf == 3 ) ? false : true,
				'RESTWURF'		=> ($neu == 1) ? $user->lang['NEW'] : $button,

			));
		break;

		case 'wurf':
			// Spieler würfelt
			$page_title = $user->lang['KNOBELBECHER'];
			$s_hidden_fields['mode'] = 'play';
			$anzwurf++;
			$refresh = true;
			$do_schabernack = ($CONF['schaber_tr'] == 1 || $CONF['schaber_vt'] == 1) ? true : false;
			$schabernack = $nvt = $checkbox = $random = false;
			$button = $user->lang['STOP_KNOBELBECHER'];

			if ($anzwurf == 4)
			{
				$refresh = false;
				$wurfel = array($result['wurfel1'], $result['wurfel2'], $result['wurfel3'], $result['wurfel4'], $result['wurfel5'], $result['wurfel6']);
				$message[] = $user->lang['EINTRAGEN'];
			}
			else
			{
				$unhold = array();
				for ($i = 1; $i < 7; $i++)
				{
					$a = $i - 1;
					if ($result['wurfel'.$i] == 20)
					{
						#$debug[] = 'Würfel '.$i.' unhold';
						unset($hold[$i]);
						$result['wurfel'.$i] = 0;
						$schabernack = false;
						$do_schabernack = false;
					}
					if ($result['wurfel'.$i] == 15)
					{
						#$debug[] = 'Würfel '.$i.' schabernack 15';
						$hold[$i] = true;
						$schabernack = 15;
						$do_schabernack = false;
					}
					if ($do_schabernack)
					{
						// Welche Würfel sind nicht gehalten für Schabernack ermitteln
						if (!isset($hold[$i]))
						{
							$unhold[$i] = $i;
						}
					}
				}

				// Schabernack ist an.
				if ($do_schabernack)
				{
					$treffer = array_rand($unhold);
					#$debug[] = '$unhold = '.print_r($unhold,true);
					#$debug[] = 'möglich Würfel = '.$treffer;
					// Würfel Stapel treffer bei 20
					if ($CONF['schaber_tr'] == 1 && !$schabernack && count($unhold) > 1)
					{
						$schabernack = (rand_wuerfel(20,$CONF['tr_rand_wert']) == 20) ? 20 : false;
					}
					// Würfel vom Tisch treffer bei 15
					if ($CONF['schaber_vt'] == 1 && !$schabernack)
					{
						$schabernack = (rand_wuerfel(15,$CONF['vt_rand_wert']) == 20) ? 15 : false;
					}
					// Trifft Schabernack?
					if ($schabernack)
					{
						#$debug[] = '$schabernack = '.$schabernack;
						$result['wurfel'.$treffer] = $schabernack;
						$refresh = false;
						switch ($schabernack)
						{
							case 15:
								$message[] = $user->lang['ERROR_VOM_TISCH'];
								$button = false;
								$hold[$treffer] = 1;
								$anzwurf = 3;
							break;
							case 20:
								$s_hidden_fields['mode'] = 'wurf';
								$message[] = $user->lang['ERROR_TURM'];
								$s_hidden_fields['mode'] = 'wurf';
								$checkbox = true;
								unset($hold[$treffer]);
								$anzwurf = ($anzwurf > 0) ? $anzwurf - 1 : 0;
								$restwurf = (int) 3 - $anzwurf;
								$button = ($restwurf == 1) ? $user->lang['RESTWURF'] : sprintf($user->lang['RESTWURFE'], $restwurf);
							break;
							default:
							break;
						}
					}
				}

				for ($i = 1; $i < 7; $i++)
				{
					$a = $i -1;
					if (isset($hold[$i]) && $anzwurf > 0)
					{
						$halten[$a] = 1;
						$eintrag[$i] = $result['wurfel'.$i];
						$wurfel[$a] = $result['wurfel'.$i];
					}
					else
					{
						if ($schabernack)
						{
							$num = ($result['wurfel'.$i] == 0) ? rand_wuerfel(1,6) : $result['wurfel'.$i];
							$wurfel[$a] = $num;
						}
						else
						{
							$num = rand_wuerfel(1,6);
							$wurfel[$a] = 'random_'.$num;
						}
						$halten[$a] = (!isset($hold[$i])) ? 0 : 1;
						$eintrag[$i] = $num;
					}
				}

				$do_hold = ($checkbox) ? do_hold($halten) : false;
				#$debug[] = 'schabernack = '.$schabernack;

				$sql = 'UPDATE ' . KNIFFEL_USER_TABLE . " SET wurf='$anzwurf', wurfel1='{$eintrag[1]}', wurfel2='{$eintrag[2]}', wurfel3='{$eintrag[3]}', wurfel4='{$eintrag[4]}', wurfel5='{$eintrag[5]}', wurfel6='{$eintrag[6]}', c1='{$halten[0]}', c2='{$halten[1]}', c3='{$halten[2]}', c4='{$halten[3]}', c5='{$halten[4]}', c6='{$halten[5]}' WHERE userid=$uid";
				$db->sql_query($sql);
			}

			wgrafik($wurfel);
			$higscore = simple_hiscore();
			fill_ergebniss($result, $ergebnis);

			if ( $refresh )
			{
				meta_refresh($refreshtime, append_sid("{$phpbb_root_path}superkniffel.$phpEx"));
			}

			$template->assign_vars(array(
				'S_PLAY_KNIFFEL'	=> true,
				'S_WUERFEL'		=> true,
				'S_KNOBELBECHER'	=> ($button && $anzwurf < 4) ? true : false,
				'RESTWURF'		=> ($button) ? $button : false,
			));
		break;

		case 'eintrag':
			// Spieler trägt eine Runde ein
			$page_title = $user->lang['SAFE_POINTS'];
			$s_hidden_fields['mode'] = 'wurf';
			$error = $nochmal = false;
			// eintragen
			$eintrag = request_var('write', '');
			$augen = 0;
			$button = ($restwurf == 1) ? $user->lang['RESTWURF'] : sprintf($user->lang['RESTWURFE'], $restwurf);
			$wurfel = array($result['wurfel1'], $result['wurfel2'], $result['wurfel3'], $result['wurfel4'], $result['wurfel5'], $result['wurfel6']);
			$zate = array();
			for ($i = 1; $i < 7; $i++)
			{
				$a = $i -1;
				// Vom Tisch und Turm == 0
				$zahl = ($result['wurfel'.$i] > 6) ? 0 : $result['wurfel'.$i];
				array_push($zate, $zahl);
			}

			if ( $result['wurf'] == 0 )
			{
				$error = true;
				$nochmal = true;
				$message[] = $user->lang['ERROR_NEXT_STRIKE'];
				$button = $user->lang['NEXT_STRIKE'];
			}

			if (!$error)
			{
				// $result[$eintrag] existiert nicht
				if ( !array_key_exists($eintrag, $result) )
				{
					$message[] = sprintf($user->lang['ERROR_NO_FIELD'], strtoupper($eintrag));
					$error = true;
				}
				$kette = zate($zate);
				$waslos = ermitteln($kette);
				$checker = checker($kette);
				$Super_Kniffel = false;

				// ist ein Super-Kniffel
				if ($waslos == 9 || $waslos == 29 || $waslos == 39)
				{
					$Super_Kniffel = true;
				}
				// $result[$eintrag] < 99 und kein Superkniffel Wurde schon eingetragen
				if ( !$error && $result[$eintrag] < 99 && !$Super_Kniffel )
				{
					$message[] = sprintf($user->lang['ERROR_EXISTS'], strtoupper($eintrag));
					$error = true;
				}

				if (!$error)
				{
					$zahlen_array = array(1 => 'einer', 2 => 'zweier', 3 => 'dreier', 4 => 'vierer', 5 => 'funfer', 6 => 'sechser');
					$rest_array = array('dpasch', 'vpasch', 'fpasch', 'dopasch', 'gpasch', 'upasch', 'trpasch', 'crpasch', 'fullh', 'kstra', 'gstra', 'allee', 'kniffel', 'chance');
					foreach ($zahlen_array as $k => $v)
					{
						if ( $v == $eintrag)
						{
							$augen = augen($kette,$k);
							$result['zsumm1'] += $augen;
							$bonus = bonus($result['zsumm1']);
							if ( $bonus > 0 && $result['bonus'] < 85)
							{
								if ($result['bonus'] == 0)
								{
									$bonus += ($bonus == 50) ? 35 : 0;
									$result['bonus'] = $bonus;
									$message[] = sprintf($user->lang['PUT_BONUS'], $bonus);
								}
								if ($result['bonus'] == 35 && $bonus == 50 )
								{
									$result['bonus'] += $bonus;
									$message[] = sprintf($user->lang['PUT_NEXT_BONUS'], $bonus);
								}
							}
						}
					}
					switch($eintrag)
					{
						case 'dpasch':
							$augen = punkte($zate);
							if ( !in_array($waslos, array(1,2,3,4,5,9,21,22,23,24,25,29,31,32,33,34,35,39,41,55,66,76) ) && !$Super_Kniffel )
							{
								$augen = 0;
								if ( $result['wurf'] < 3 )
								{
									$error = true;
									$nochmal = true;
								}
							}
							$result['zsumm2'] += $augen;
						break;
						case 'vpasch':
							$augen = punkte($zate);
							if ( !in_array($waslos, array(2,3,5,9,22,23,25,29,32,33,35,39) ) && !$Super_Kniffel )
							{
								$augen = 0;
								if ( $result['wurf'] < 3 )
								{
									$error = true;
									$nochmal = true;
								}
							}
							$result['zsumm2'] += $augen;
						break;
						case 'fpasch':
							$augen = punkte($zate);
							if ( !in_array($waslos, array(3,9,23,33,29) ) && !$Super_Kniffel )
							{
								$augen = 0;
								if ( $result['wurf'] < 3 )
								{
									$error = true;
									$nochmal = true;
								}
							}
							$result['zsumm2'] += $augen;
						break;
						case 'dopasch':
							$augen = punkte($zate);
							if ( !in_array($waslos, array(4,24,34) ) )
							{
								$augen = 0;
								if ( $result['wurf'] < 3 )
								{
									$error = true;
									$nochmal = true;
								}
							}
							$result['zsumm2'] += $augen;
						break;
						case 'trpasch':
							$augen = punkte($zate);
							if ( !in_array($waslos, array(40,26,36) ) )
							{
								$augen = 0;
								if ( $result['wurf'] < 3 )
								{
									$error = true;
									$nochmal = true;
								}
							}
							$result['zsumm2'] += $augen;
						break;
						case 'crpasch':
							$augen = punkte($zate);
							if ( !in_array($waslos, array(41,76,66) ) )
							{
								$augen = 0;
								if ( $result['wurf'] < 3 )
								{
									$error = true;
									$nochmal = true;
								}
							}
							$result['zsumm2'] += $augen;
						break;
						case 'gpasch':
							$augen = punkte($zate);
							if ( !in_array($waslos, array(20,21,22,23,24,25,26,29,66) ) )
							{
								$augen = 0;
								if ( $result['wurf'] < 3 )
								{
									$error = true;
									$nochmal = true;
								}
							}
							$result['zsumm2'] += $augen;
						break;
						case 'upasch':
							$augen = punkte($zate);
							if ( !in_array($waslos, array(30,31,32,33,34,35,36,39,76) ) )
							{
								$augen = 0;
								if ( $result['wurf'] < 3 )
								{
									$error = true;
									$nochmal = true;
								}
							}
							$result['zsumm2'] += $augen;
						break;
						case 'fullh':
							$augen = punkte($zate);
							if ( !in_array($waslos, array(5,25,35) ) )
							{
								$augen = 0;
								if ( $result['wurf'] < 3 )
								{
									$error = true;
									$nochmal = true;
								}
							}
							$result['zsumm2'] += $augen;
						break;
						case 'kstra':
							$augen = 40;
							if ( !in_array($waslos, array(6,7,8,55) ) )
							{
								$augen = 0;
								if ( $result['wurf'] < 3 )
								{
									$error = true;
									$nochmal = true;
								}
							}
							$result['zsumm2'] += $augen;
						break;
						case 'gstra':
							$augen = 50;
							if ( !in_array($waslos, array(7,8) ) )
							{
								$augen = 0;
								if ( $result['wurf'] < 3 )
								{
									$error = true;
									$nochmal = true;
								}
							}
							$result['zsumm2'] += $augen;
						break;
						case 'allee':
							$augen = 60;
							if ( !in_array($waslos, array(8) ) )
							{
								$augen = 0;
								if ( $result['wurf'] < 3 )
								{
									$error = true;
									$nochmal = true;
								}
							}
							$result['zsumm2'] += $augen;
						break;
						case 'kniffel':
							$augen = 100;
							if ( !in_array($waslos, array(9,29,39) ) )
							{
								$augen = 0;
								if ( $result['wurf'] < 3 )
								{
									$error = true;
									$nochmal = true;
								}
							}
							$result['zsumm2'] += $augen;
						break;
						case 'chance':
							$augen = punkte($zate);
							// Nur $nochmal wenn nicht letzter Wurf
							if ( $result['wurf'] < 3 && $result['zaehler'] < 19)
							{
								$error = true;
								$nochmal = true;
							}
							$result['zsumm2'] += $augen;
						break;
						default:
						break;
					}

					// Superniffel!
					if ($Super_Kniffel && !$error)
					{
						if ($eintrag != 'kniffel')
						{
							$result['zsumm2'] += 100;
							$message[] = $user->lang['KNIFFEL_EXTRA'];
						}
					}
				}
			}
			wgrafik($wurfel);

			if ($error)
			{
				if ($restwurf > 0 && $result['wurf'] > 0)
				{
					$checked[0] = $result['c1'];
					$checked[1] = $result['c2'];
					$checked[2] = $result['c3'];
					$checked[3] = $result['c4'];
					$checked[4] = $result['c5'];
					$checked[5] = $result['c6'];
					do_hold($checked);
				}
				if ($nochmal && $result['wurf'] > 0)
				{
					$message[] = sprintf($user->lang['ERROR_RESTWURF'], 3 - $result['wurf']);
				}
			}
			else
			{
				$result[$eintrag] = $augen;
				$ergebnis[$eintrag] = $checker;
				$result['wurf'] = 0;
				$result['zaehler'] += 1;

				// Spiel fertig ab in Higscore
				if ($result['zaehler'] == 20)
				{
					$konto = $result['zsumm1'] + $result['zsumm2'] + $result['bonus'];
					$time = time();
					$sql = 'SELECT nr, score_date, points, games, score_array
						FROM ' . KNIFFEL_HIGSCORE_TABLE . '
						WHERE userid = '.$uid.' && monat = '.$monat.' && jahr = '.$jahr.'
						ORDER BY points DESC';
					$sql1 = $db->sql_query($sql);
					$score_count = 0;

					$serialize = array('einer'	=> array($ergebnis['einer'], $result['einer']),
							'zweier'	=> array($ergebnis['zweier'], $result['zweier']),
							'dreier'	=> array($ergebnis['dreier'], $result['dreier']),
							'vierer'	=> array($ergebnis['vierer'], $result['vierer']),
							'funfer'	=> array($ergebnis['funfer'], $result['funfer']),
							'sechser'	=> array($ergebnis['sechser'], $result['sechser']),
							'dpasch'	=> array($ergebnis['dpasch'], $result['dpasch']),
							'vpasch'	=> array($ergebnis['vpasch'], $result['vpasch']),
							'fpasch'	=> array($ergebnis['fpasch'], $result['fpasch']),
							'dopasch'	=> array($ergebnis['dopasch'], $result['dopasch']),
							'trpasch'	=> array($ergebnis['trpasch'], $result['trpasch']),
							'crpasch'	=> array($ergebnis['crpasch'], $result['crpasch']),
							'gpasch'	=> array($ergebnis['gpasch'], $result['gpasch']),
							'upasch'	=> array($ergebnis['upasch'], $result['upasch']),
							'fullh'		=> array($ergebnis['fullh'], $result['fullh']),
							'kstra'		=> array($ergebnis['kstra'], $result['kstra']),
							'gstra'		=> array($ergebnis['gstra'], $result['gstra']),
							'allee'		=> array($ergebnis['allee'], $result['allee']),
							'kniffel'	=> array($ergebnis['kniffel'], $result['kniffel']),
							'chance'	=> array($ergebnis['chance'], $result['chance'])
							);

					$score_array = $db->sql_escape(serialize($serialize));
					// ältere Versionen hatten noch alle Spiele gespeichert
					while ($row = $db->sql_fetchrow($sql1))
					{
						$score_count++;
						// Nur ein Eintrag!
						if ($score_count == 1)
						{
							if ($konto > $row['points'])
							{
								$row['points'] = $konto;
								$row['score_date'] = $time;
								$row['score_array'] = $score_array;
							}
							$result['games'] += (int) $row['games'];
							$up_sql = 'UPDATE ' . KNIFFEL_HIGSCORE_TABLE . "
								SET score_date = ".$row['score_date'].", points = '".$row['points']."', games = '".$result['games']."', score_array = '".$row['score_array']."'
								WHERE nr = " . $row['nr'];
							$db->sql_query($up_sql);
						}
						if ($score_count > 1)
						{
							$delete_sql = 'DELETE FROM ' . KNIFFEL_HIGSCORE_TABLE . ' WHERE nr = ' . $row['nr'];
							$db->sql_query($delete_sql);
						}
					}
					$db->sql_freeresult($sql);
					// kein Eintrag in der highscore Tabelle ?
					if ($score_count == 0)
					{
						#$result['games']++;
						$sql = 'INSERT INTO ' . KNIFFEL_HIGSCORE_TABLE . " (userid, monat, jahr, score_date, points, games, score_array) VALUES ('$uid', '$monat', '$jahr', '$time', '$konto', '".$result['games']."', '$score_array')";
						$db->sql_query($sql);
					}
					$sql = 'DELETE FROM ' . KNIFFEL_USER_TABLE . ' WHERE userid = '.$uid;
					$db->sql_query($sql);
					$sql = 'DELETE FROM ' . KNIFFEL_WURF_TABLE . ' WHERE userid = '.$uid;
					$db->sql_query($sql);
					$message[] = sprintf($user->lang['END_GAME'], $konto);
					$neu = 1;
					#$error = true;
				}
				else
				{
					// Wert in kniffel_wurf schreiben
					$sql = 'UPDATE ' . KNIFFEL_WURF_TABLE . " SET $eintrag='$checker' WHERE userid='$uid'";
					$db->sql_query($sql);
					// werte für KNIFFEL_USER_TABLE
					$sql = 'UPDATE ' . KNIFFEL_USER_TABLE . " SET wurf='".$result['wurf']."', wurfel1 = 0, wurfel2 = 0, wurfel3 = 0, wurfel4 = 0, wurfel5 = 0, wurfel6 = 0, $eintrag='$augen', zaehler=".$result['zaehler'].", bonus=".$result['bonus'].", zsumm1=".$result['zsumm1'].", zsumm2=".$result['zsumm2'].", c1='0', c2='0', c3='0', c4='0', c5='0', c6='0' WHERE userid='$uid'";
					$db->sql_query($sql);
					$message[] = sprintf($user->lang['SAFE_WURF'], $augen);
				}

			}
			$higscore = simple_hiscore();
			fill_ergebniss($result, $ergebnis);
			#$debug[] = print_r($result, true);
			$template->assign_vars(array(
				'S_PLAY_KNIFFEL'	=> true,
				'S_WUERFEL'		=> true,
				'S_KNOBELBECHER'	=> true,
				'RESTWURF'		=> (!$error) ? ($neu == 1) ? $user->lang['NEW'] : $user->lang['NEXT_STRIKE'] : $button,

			));
		break;

		case 'highscore':
			$page_title = $user->lang['PLAY'] . ' ' . $user->lang['HIGHSCORE_TEXT'];
			// Alltime bestenliste anzahl ermittel
			$top = (int) request_var('top', 3);
			$top = ($top > 25) ? 25 : $top;
			// Monat
			$mon = (int) request_var('mon', $monat);
			// Jahr
			$year = (int) request_var('year', $jahr);

			$top3 = simple_hiscore($top, true, true);
			$detail_link = append_sid("{$phpbb_root_path}superkniffel.$phpEx", 'mode=details&amp;nr=');
			$c = count($top3);
			if ($c > 0)
			{
				$Rang = 1;
				for ($i =0; $i < $c; $i++)
				{
					$image_name = ($Rang > 3) ? 'no_place' : $Rang;
					$details = (strlen($top3[$i][5]) > 1) ?  $detail_link . $top3[$i][4] : false;
					$template->assign_block_vars('alltim_record_user', array(
						'RANG'		=> $Rang,
						'R_IMAGENAME'	=> $image_name,
						'R_NAME'	=> $top3[$i][2],
						'R_POINTS'	=> $top3[$i][1],
						'R_TIME'	=> $user->format_date($top3[$i][3]),
						'S_DETAILS'	=> $details,
					));
					$Rang++;
				}
			}

			// Monate ausgeben
			quartal_info($mon,$year,2);

			$scoreurl = append_sid("{$phpbb_root_path}superkniffel.$phpEx", 'mode=highscore&amp;top=');
			for ($i = 5; $i < 26; $i += 5)
			{
				$template->assign_block_vars('topnavi', array(
					'S_URL'		=> $scoreurl . $i,
					'L_COUNT'	=> $i
				));

			}
			$template->assign_vars(array(
				'DEBUG_TEXT'		=> ( is_array($debug) ) ? '<p><pre>'.implode("\n", $debug).'</pre></p>' : '',
				'S_HIGHSCORE'		=> true,
				'S_MONAT_ROW'		=> true,
				'L_HIGESCORE_ALLTIME'	=> sprintf($user->lang['HIGESCORE_ALLTIME'], $top),
				'L_MAN_TITLE'		=> $user->lang['SHOW_MAN'],
				'L_MAN_TEXT'		=> $user->lang['MAN'],
				'S_IMAGE_DIR'		=> $phpbb_root_path.'images/superkniffel/',
				'PLAY_LINK'			=> append_sid("{$phpbb_root_path}superkniffel.$phpEx", 'mode=play'),
				'MAN_LINK'			=> append_sid("{$phpbb_root_path}superkniffel.$phpEx", 'mode=des'),
			));
			// Output the page
			page_header($page_title);
			$template->set_filenames(array(
				'body' => 'superkniffel.html'
			));

			page_footer();
		break;
		case 'des':
			// Anleitung anzeigen
			$page_title = $user->lang['MAN'];
			$beschreibung = $user->lang['BESCHREIBUNG'];
			if ($CONF['schaber_tr'])
			{
				$beschreibung .= sprintf($user->lang['BESCHREIBUNG_TR'], $phpbb_root_path.'images/superkniffel/', $CONF['tr_rand']);
			}
			if ($CONF['schaber_vt'])
			{
				$beschreibung .= sprintf($user->lang['BESCHREIBUNG_VT'], $phpbb_root_path.'images/superkniffel/', $CONF['vt_rand']);
			}
			$template->assign_vars(array(
				'S_MAN'		=> true,
				'L_MAN_TITLE'	=> $user->lang['SHOW_MAN'],
				'L_MAN_TEXT'	=> $user->lang['MAN'],
				'L_BESCHREIBUNG'	=> $beschreibung,
				'PLAY_LINK'		=> append_sid("{$phpbb_root_path}superkniffel.$phpEx", 'mode=play'),
				'HIGHSCORE_LINK'	=> append_sid("{$phpbb_root_path}superkniffel.$phpEx", 'mode=highscore'),
			));

			// Output the page
			page_header($page_title);
			$template->set_filenames(array(
				'body' => 'superkniffel.html'
			));

			page_footer();
		break;

		case 'details';
			// Details zu einem Wurf anzeigen
			$nr = (int) request_var('nr', 0);

			$sql = 'SELECT k.nr, k.score_date, k.points, k.games, k.score_array, u.user_id AS userid, u.username, u.user_colour
				FROM ' . KNIFFEL_HIGSCORE_TABLE . ' k
				LEFT JOIN ' . USERS_TABLE . ' u on (u.user_id = k.userid)
				WHERE nr = '.$nr;
			$res = $db->sql_query_limit($sql, 1);
			$row = $db->sql_fetchrow($res);
			$db->sql_freeresult($res);

			if (!$row || strlen($row['score_array']) < 2)
			{
				trigger_error('DETAIL_NOT_FOUND');
			}

			$arr = unserialize($row['score_array']);
			if (!is_array($arr) or count($arr) <= 1)
			{
				trigger_error('DETAIL_NOT_FOUND');
			}

			$page_title = sprintf($user->lang['DETAIL_TITLE'], $row['points'], $row['username']);
			$ergebnis = array();
			$result = array();
			foreach ($arr AS $k => $v)
			{
				$ergebnis[$k]	= $v[0];
				$result[$k]		= $v[1];
			}
			$result['zsumm1'] = ($result['einer'] + $result['zweier'] + $result['dreier'] + $result['vierer'] + $result['funfer'] + $result['sechser']);
			$bonus = bonus($result['zsumm1']);
			$result['bonus'] = ($bonus == 50) ? 85 : $bonus;
			$result['zsumm2'] = ($result['dpasch'] + $result['vpasch'] + $result['fpasch'] + $result['dopasch'] + $result['gpasch'] + $result['upasch'] + $result['trpasch'] + $result['crpasch'] + $result['fullh'] + $result['kstra'] + $result['gstra'] + $result['allee'] + $result['kniffel'] + $result['chance']);
			$poinst = (int)$result['zsumm1'] + (int)$result['bonus'] + (int)$result['zsumm2'];
			$extrakniffel = '';
			if ( $row['points'] > $poinst )
			{
				$kniffelcount = ($row['points'] - $poinst) / 100;
				$extrakniffel = sprintf($user->lang['DETAIL_EXTRA_KNIFFEL'], $kniffelcount, $row['points']);
			}
			fill_ergebniss($result, $ergebnis);
			$username = get_username_string('full', $row['userid'], $row['username'], $row['user_colour']);
			$template->assign_vars(array(
				'S_PLAY_KNIFFEL'		=> true,
				'S_WUERFEL'			=> false,
				'S_KNOBELBECHER'		=> false,
				'S_HIGHSCORE_DETAILS'	=> true,
				'RESTWURF'			=> false,
				'MESSAGES'			=> sprintf($user->lang['DETAIL_TITLE'], $poinst, $username) . $extrakniffel,
				'L_MAN_TITLE'		=> $user->lang['SHOW_MAN'],
				'L_MAN_TEXT'		=> $user->lang['MAN'],
				'L_RESET'			=> $user->lang['PLAY'],
				'RESET_LINK'		=> append_sid("{$phpbb_root_path}superkniffel.$phpEx", 'mode=play'),
				'HIGHSCORE_LINK'		=> append_sid("{$phpbb_root_path}superkniffel.$phpEx", 'mode=highscore'),
				'MAN_LINK'			=> append_sid("{$phpbb_root_path}superkniffel.$phpEx", 'mode=des'),
			));

			// Output the page
			page_header($page_title);
			$template->set_filenames(array(
				'body' => 'superkniffel.html'
			));

			page_footer();
		break;

		case 'config':
			if (!$is_admin)
			{
				trigger_error('NO_AUTH_ADMIN', E_USER_ERROR);
			}
			// Configuration
			$safe = request_var('safe', false);
			$page_title = $user->lang['PLAY'] . ' ' . $user->lang['CONF'];
			$s_hidden_fields['mode'] = 'config';
			$s_hidden_fields['safe'] = 'submit';
			if ($safe)
			{
				$CONF['schaber_vt'] = (request_var('schaber_vt', false)) ? 1 : 0;
				$CONF['schaber_tr'] = (request_var('schaber_tr', false)) ? 1 : 0;

				$CONF['vt_rand'] = (int) request_var('vt_rand', 10);
				$CONF['vt_rand'] = ($CONF['vt_rand'] > 100) ? 100 : $CONF['vt_rand'];
				if ($CONF['vt_rand'] > 0)
				{
					$CONF['vt_rand_wert'] = round((20 / $CONF['vt_rand']) * 100, 0);
					#$debug[] = 'vt_rand_wert = '.$CONF['vt_rand_wert'];
				}
				else
				{
					$CONF['schaber_vt'] = false;
				}

				$CONF['tr_rand'] = (int) request_var('tr_rand', 10);
				$CONF['tr_rand'] = ($CONF['tr_rand'] > 100) ? 100 : $CONF['tr_rand'];
				if ($CONF['tr_rand'] > 0)
				{
					$CONF['tr_rand_wert'] = round((15 / $CONF['tr_rand']) * 100, 0);
					#$debug[] = 'tr_rand_wert = '.$CONF['tr_rand_wert'];
				}
				else
				{
					$CONF['schaber_tr'] = false;
				}

				safe_config($CONF);
				$debug[] = $user->lang['CONF_SAVE_OKAY'];
			}
			$template->assign_vars(array(
				'S_CONFIG'		=> true,
				'S_HIDDEN_FIELDS'	=> build_hidden_fields($s_hidden_fields),
				'S_CONF_ACTION'	=> append_sid("{$phpbb_root_path}superkniffel.$phpEx"),
				'HIGHSCORE_LINK'	=> append_sid("{$phpbb_root_path}superkniffel.$phpEx", 'mode=highscore'),
				'MAN_LINK'		=> append_sid("{$phpbb_root_path}superkniffel.$phpEx", 'mode=des'),
				'PLAY_LINK'		=> append_sid("{$phpbb_root_path}superkniffel.$phpEx", 'mode=play'),
				'L_MAN_TITLE'	=> $user->lang['SHOW_MAN'],
				'L_MAN_TEXT'	=> $user->lang['MAN'],
				'SVTG_ENABLED'	=> $CONF['schaber_vt'],
				'STR_ENABLED'	=> $CONF['schaber_tr'],
				'VT_RAND'		=> (int) $CONF['vt_rand'],
				'TR_RAND'		=> (int) $CONF['tr_rand'],
				'DEBUG_TEXT'	=> ( is_array($debug) ) ? '<p><pre>'.implode("\n", $debug).'</pre></p>' : '',
			));
			// Output the page
			page_header($page_title);
			$template->set_filenames(array(
				'body' => 'superkniffel.html'
			));

			page_footer();
		break;

		default:
		break;
	}

$template->assign_vars(array(
	'S_PLAY_ACTION'	=> append_sid("{$phpbb_root_path}superkniffel.$phpEx", false, true, 0),
	'S_HIDDEN_FIELDS'	=> build_hidden_fields($s_hidden_fields),
	'WUERFEL_DIR'	=> $phpbb_root_path.'images/superkniffel/',
	'L_RESET'		=> $user->lang['RESET_GAME'],
	'L_MAN_TITLE'	=> $user->lang['SHOW_MAN'],
	'L_MAN_TEXT'	=> $user->lang['MAN'],
	'L_MONAT'		=> $user->lang['datetime'][$monat_name[$monat]],
	'HIGHSCORE_LINK'	=> append_sid("{$phpbb_root_path}superkniffel.$phpEx", 'mode=highscore'),
	'RESET_LINK'	=> append_sid("{$phpbb_root_path}superkniffel.$phpEx", 'neu=1'),
	'MAN_LINK'		=> append_sid("{$phpbb_root_path}superkniffel.$phpEx", 'mode=des'),
	'MESSAGES'		=> ( is_array($message)) ? implode("\n", $message) : false,
	'DEBUG_TEXT'	=> ( is_array($debug) ) ? '<p><pre>'.implode("\n", $debug).'</pre></p>' : '',
	'S_HIGESCORE'	=> ($higscore) ? true : false,
	'L_HIGESCORE'	=> ($higscore && is_array($higscore)) ? implode("\n<h3></h3>", $higscore) : '',
));

// Output the page
page_header($page_title);
$template->set_filenames(array(
	'body' => 'superkniffel.html'
));

page_footer();
?>