#
# $Id: $
#

# Table: 'phpbb_kniffel_highscore'
CREATE TABLE phpbb_kniffel_highscore (
	nr int(11) UNSIGNED NOT NULL auto_increment,
	userid int(11) UNSIGNED DEFAULT '0' NOT NULL,
	monat tinyint(1) UNSIGNED DEFAULT '0' NOT NULL,
	jahr smallint(4) UNSIGNED DEFAULT '0' NOT NULL,
	score_date int(11) UNSIGNED DEFAULT '0' NOT NULL,
	points int(11) UNSIGNED DEFAULT '0' NOT NULL,
	games int(11) UNSIGNED DEFAULT '1' NOT NULL,
	score_array text NOT NULL,
	PRIMARY KEY (nr),
	KEY monat (points,score_date),
	KEY jahr (jahr)
) CHARACTER SET `utf8` COLLATE `utf8_bin`;


# Table: 'phpbb_kniffel_wurf'
CREATE TABLE phpbb_kniffel_wurf (
	userid int(11) UNSIGNED DEFAULT '0' NOT NULL,
	einer char(6) DEFAULT '0' NOT NULL,
	zweier char(6) DEFAULT '0' NOT NULL,
	dreier char(6) DEFAULT '0' NOT NULL,
	vierer char(6) DEFAULT '0' NOT NULL,
	funfer char(6) DEFAULT '0' NOT NULL,
	sechser char(6) DEFAULT '0' NOT NULL,
	dpasch char(6) DEFAULT '0' NOT NULL,
	vpasch char(6) DEFAULT '0' NOT NULL,
	fpasch char(6) DEFAULT '0' NOT NULL,
	dopasch char(6) DEFAULT '0' NOT NULL,
	trpasch char(6) DEFAULT '0' NOT NULL,
	crpasch char(6) DEFAULT '0' NOT NULL,
	gpasch char(6) DEFAULT '0' NOT NULL,
	upasch char(6) DEFAULT '0' NOT NULL,
	fullh char(6) DEFAULT '0' NOT NULL,
	kstra char(6) DEFAULT '0' NOT NULL,
	gstra char(6) DEFAULT '0' NOT NULL,
	allee char(6) DEFAULT '0' NOT NULL,
	kniffel char(6) DEFAULT '0' NOT NULL,
	chance char(6) DEFAULT '0' NOT NULL,
	PRIMARY KEY (userid)
) CHARACTER SET `utf8` COLLATE `utf8_bin`;


# Table: 'phpbb_kniffel_user'
CREATE TABLE phpbb_kniffel_user (
	userid int(11) UNSIGNED DEFAULT '0' NOT NULL,
	wurf tinyint(1) UNSIGNED DEFAULT '0' NOT NULL,
	wurfel1 tinyint(1) UNSIGNED DEFAULT '0' NOT NULL,
	wurfel2 tinyint(1) UNSIGNED DEFAULT '0' NOT NULL,
	wurfel3 tinyint(1) UNSIGNED DEFAULT '0' NOT NULL,
	wurfel4 tinyint(1) UNSIGNED DEFAULT '0' NOT NULL,
	wurfel5 tinyint(1) UNSIGNED DEFAULT '0' NOT NULL,
	wurfel6 tinyint(1) UNSIGNED DEFAULT '0' NOT NULL,
	zaehler tinyint(1) UNSIGNED DEFAULT '0' NOT NULL,
	einer tinyint(1) UNSIGNED DEFAULT '99' NOT NULL,
	zweier tinyint(1) UNSIGNED DEFAULT '99' NOT NULL,
	dreier tinyint(1) UNSIGNED DEFAULT '99' NOT NULL,
	vierer tinyint(1) UNSIGNED DEFAULT '99' NOT NULL,
	funfer tinyint(1) UNSIGNED DEFAULT '99' NOT NULL,
	sechser tinyint(1) UNSIGNED DEFAULT '99' NOT NULL,
	dpasch tinyint(1) UNSIGNED DEFAULT '99' NOT NULL,
	vpasch tinyint(1) UNSIGNED DEFAULT '99' NOT NULL,
	fpasch tinyint(1) UNSIGNED DEFAULT '99' NOT NULL,
	dopasch tinyint(1) UNSIGNED DEFAULT '99' NOT NULL,
	trpasch tinyint(1) UNSIGNED DEFAULT '99' NOT NULL,
	crpasch tinyint(1) UNSIGNED DEFAULT '99' NOT NULL,
	gpasch tinyint(1) UNSIGNED DEFAULT '99' NOT NULL,
	upasch tinyint(1) UNSIGNED DEFAULT '99' NOT NULL,
	fullh tinyint(1) UNSIGNED DEFAULT '99' NOT NULL,
	kstra tinyint(1) UNSIGNED DEFAULT '99' NOT NULL,
	gstra tinyint(1) UNSIGNED DEFAULT '99' NOT NULL,
	allee tinyint(1) UNSIGNED DEFAULT '99' NOT NULL,
	kniffel tinyint(1) UNSIGNED DEFAULT '99' NOT NULL,
	chance tinyint(1) UNSIGNED DEFAULT '99' NOT NULL,
	bonus tinyint(1) UNSIGNED DEFAULT '0' NOT NULL,
	zsumm1 smallint(4) UNSIGNED DEFAULT '0' NOT NULL,
	zsumm2 smallint(4) UNSIGNED DEFAULT '0' NOT NULL,
	games int(11) UNSIGNED DEFAULT '1' NOT NULL,
	c1 tinyint(1) UNSIGNED DEFAULT '0' NOT NULL,
	c2 tinyint(1) UNSIGNED DEFAULT '0' NOT NULL,
	c3 tinyint(1) UNSIGNED DEFAULT '0' NOT NULL,
	c4 tinyint(1) UNSIGNED DEFAULT '0' NOT NULL,
	c5 tinyint(1) UNSIGNED DEFAULT '0' NOT NULL,
	c6 tinyint(1) UNSIGNED DEFAULT '0' NOT NULL,
	PRIMARY KEY (userid)
) CHARACTER SET `utf8` COLLATE `utf8_bin`;


