#
# $Id: $
#

BEGIN TRANSACTION;

# Table: 'phpbb_kniffel_highscore'
CREATE TABLE phpbb_kniffel_highscore (
	nr INTEGER PRIMARY KEY NOT NULL ,
	userid INTEGER UNSIGNED NOT NULL DEFAULT '0',
	monat INTEGER UNSIGNED NOT NULL DEFAULT '0',
	jahr INTEGER UNSIGNED NOT NULL DEFAULT '0',
	score_date INTEGER UNSIGNED NOT NULL DEFAULT '0',
	points INTEGER UNSIGNED NOT NULL DEFAULT '0',
	games INTEGER UNSIGNED NOT NULL DEFAULT '1',
	score_array text(65535) NOT NULL 
);

CREATE INDEX phpbb_kniffel_highscore_monat ON phpbb_kniffel_highscore (points,score_date);
CREATE INDEX phpbb_kniffel_highscore_jahr ON phpbb_kniffel_highscore (jahr);

# Table: 'phpbb_kniffel_wurf'
CREATE TABLE phpbb_kniffel_wurf (
	userid INTEGER UNSIGNED NOT NULL DEFAULT '0',
	einer char(6) NOT NULL DEFAULT '0',
	zweier char(6) NOT NULL DEFAULT '0',
	dreier char(6) NOT NULL DEFAULT '0',
	vierer char(6) NOT NULL DEFAULT '0',
	funfer char(6) NOT NULL DEFAULT '0',
	sechser char(6) NOT NULL DEFAULT '0',
	dpasch char(6) NOT NULL DEFAULT '0',
	vpasch char(6) NOT NULL DEFAULT '0',
	fpasch char(6) NOT NULL DEFAULT '0',
	dopasch char(6) NOT NULL DEFAULT '0',
	trpasch char(6) NOT NULL DEFAULT '0',
	crpasch char(6) NOT NULL DEFAULT '0',
	gpasch char(6) NOT NULL DEFAULT '0',
	upasch char(6) NOT NULL DEFAULT '0',
	fullh char(6) NOT NULL DEFAULT '0',
	kstra char(6) NOT NULL DEFAULT '0',
	gstra char(6) NOT NULL DEFAULT '0',
	allee char(6) NOT NULL DEFAULT '0',
	kniffel char(6) NOT NULL DEFAULT '0',
	chance char(6) NOT NULL DEFAULT '0',
	PRIMARY KEY (userid)
);


# Table: 'phpbb_kniffel_user'
CREATE TABLE phpbb_kniffel_user (
	userid INTEGER UNSIGNED NOT NULL DEFAULT '0',
	wurf INTEGER UNSIGNED NOT NULL DEFAULT '0',
	wurfel1 INTEGER UNSIGNED NOT NULL DEFAULT '0',
	wurfel2 INTEGER UNSIGNED NOT NULL DEFAULT '0',
	wurfel3 INTEGER UNSIGNED NOT NULL DEFAULT '0',
	wurfel4 INTEGER UNSIGNED NOT NULL DEFAULT '0',
	wurfel5 INTEGER UNSIGNED NOT NULL DEFAULT '0',
	wurfel6 INTEGER UNSIGNED NOT NULL DEFAULT '0',
	zaehler INTEGER UNSIGNED NOT NULL DEFAULT '0',
	einer INTEGER UNSIGNED NOT NULL DEFAULT '99',
	zweier INTEGER UNSIGNED NOT NULL DEFAULT '99',
	dreier INTEGER UNSIGNED NOT NULL DEFAULT '99',
	vierer INTEGER UNSIGNED NOT NULL DEFAULT '99',
	funfer INTEGER UNSIGNED NOT NULL DEFAULT '99',
	sechser INTEGER UNSIGNED NOT NULL DEFAULT '99',
	dpasch INTEGER UNSIGNED NOT NULL DEFAULT '99',
	vpasch INTEGER UNSIGNED NOT NULL DEFAULT '99',
	fpasch INTEGER UNSIGNED NOT NULL DEFAULT '99',
	dopasch INTEGER UNSIGNED NOT NULL DEFAULT '99',
	trpasch INTEGER UNSIGNED NOT NULL DEFAULT '99',
	crpasch INTEGER UNSIGNED NOT NULL DEFAULT '99',
	gpasch INTEGER UNSIGNED NOT NULL DEFAULT '99',
	upasch INTEGER UNSIGNED NOT NULL DEFAULT '99',
	fullh INTEGER UNSIGNED NOT NULL DEFAULT '99',
	kstra INTEGER UNSIGNED NOT NULL DEFAULT '99',
	gstra INTEGER UNSIGNED NOT NULL DEFAULT '99',
	allee INTEGER UNSIGNED NOT NULL DEFAULT '99',
	kniffel INTEGER UNSIGNED NOT NULL DEFAULT '99',
	chance INTEGER UNSIGNED NOT NULL DEFAULT '99',
	bonus INTEGER UNSIGNED NOT NULL DEFAULT '0',
	zsumm1 INTEGER UNSIGNED NOT NULL DEFAULT '0',
	zsumm2 INTEGER UNSIGNED NOT NULL DEFAULT '0',
	games INTEGER UNSIGNED NOT NULL DEFAULT '1',
	c1 INTEGER UNSIGNED NOT NULL DEFAULT '0',
	c2 INTEGER UNSIGNED NOT NULL DEFAULT '0',
	c3 INTEGER UNSIGNED NOT NULL DEFAULT '0',
	c4 INTEGER UNSIGNED NOT NULL DEFAULT '0',
	c5 INTEGER UNSIGNED NOT NULL DEFAULT '0',
	c6 INTEGER UNSIGNED NOT NULL DEFAULT '0',
	PRIMARY KEY (userid)
);



COMMIT;