<?php
/**
*
* @author Super - Kniffel Smoker ( www.smokers-board.de )
* @author based on Super - Kniffel Bierhasser http://www.phpbb.de/community/memberlist.php?mode=viewprofile&u=3383
*
* @package phpbb3-SuperKniffel
* @version 1.2.0
* @copyright (c) 2009
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* DO NOT CHANGE
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

if (empty($lang) || !is_array($lang))
{
	$lang = array();
}

// DEVELOPERS PLEASE NOTE
//
// All language files should use UTF-8 as their encoding and the files must not contain a BOM.
//
// Placeholders can now contain order information, e.g. instead of
// 'Page %s of %s' you can (and should) write 'Page %1$s of %2$s', this allows
// translators to re-order the output of data while ensuring it remains correct
//
// You do not need this where single placeholders are used, e.g. 'Message %d' is fine
// equally where a string contains only two placeholders which are used to wrap text
// in a url you again do not need to specify an order e.g., 'Click %sHERE%s' is fine

$lang = array_merge($lang, array(
	'MAN'				=> 'Anleitung',
	'SHOW_MAN'			=> 'Anleitung anzeigen',
	'PLAY'			=> 'Super Kniffel',
	'PLAY_KNIFFEL'		=> 'spielt Super Kniffel',
	'KNOBELBECHER'		=> 'Knobelbecher',
	'SAFE_POINTS'		=> 'Punkte eintragen',
	'STOP_KNOBELBECHER'	=> 'Knobelbecher stoppen',
	'ERROR_NO_FIELD'		=> 'Es gibt kein Feld für <b>%s</b>!',
	'ERROR_EXISTS'		=> 'Es existiert ein Eintrag für <b>%s</b>!',
	'ERROR_RESTWURF'		=> '<h3 style="color: red">Eintrag nicht möglich</h3>Du kannst noch %d mal Würfeln. Vergib doch nicht diese Chance<h3></h3>',
	'ERROR_NEXT_STRIKE' 	=> '<h3 style="color: red">Du musst zuerst Würfeln</h3>',
	'ERROR_TURM'		=> 'Im Knobelbecher hat sich ein Würfelstapel gebildet.<br />Würfel nochmal!',
	'ERROR_VOM_TISCH'		=> 'Du warst sehr ungeschickt<br />und hast einen Würfel vom Tisch fallen lassen.<br />Du musst die vorhandenen Würfel sofort eintragen.',
	'FIRST_STRIKE'		=> 'Mache Deinen ersten Wurf.',
	'NEXT_STRIKE'		=> 'Nächste Runde',
	'LAST_STRIKE'		=> 'Du musst deine Punkte eintragen.',
	'HIGHSCORE_TITLE'		=> 'Bestenliste anzeigen',
	'HIGHSCORE_TEXT'		=> 'Bestenliste',
	'HIGESCORE_ALLTIME'	=> 'Die %d Allzeit besten Spiele',
	'HIGSCORE_EMPTY'		=> 'Keine Einträge',
	'HIGSCORE_EMPTY_TEXT'	=> 'Es wurden keine Einträge für die Monate %s gefunden.',
	'HIGSCORE_TOP'		=> 'Einträge anzeigen',
	'HIGSCORE_DETAILS'	=> 'Informationen zu diesem Eintrag anzeigen',
	'DETAIL_TITLE'		=> 'Detalierte Anzeige zum Ergebnis %d Punkte von %s',
	'DETAIL_NOT_FOUND'	=> 'Es konnte kein Eintrag gefunden werden',
	'DETAIL_EXTRA_KNIFFEL'	=> '<br />Plus <b>%1$d</b> Super Kniffel a 100 Punkte.<br />Ergibt eine Endsumme von <b>%2$d</b> Punkte',
	'MESSAGES'			=> 'Information',
	'CONF'			=> 'Konfiguration',
	'CONF_SVTG_ENABLE'	=> 'Die Schabernack Funktion "<strong>Vom Tisch gefallen</strong>" einschalten?',
	'CONF_SVTG_WERT'		=> 'Wie hoch soll die wahrscheinlichkeit sein "<strong>Vom Tisch gefallen</strong>" zu treffen?<br /><i></i>',
	'CONF_STURM_ENABLE'	=> 'Die Schabernack Funktion "<strong>Würfel Stapel</strong>" einschalten?',
	'CONF_STURM_WERT'		=> 'Wie hoch soll die wahrscheinlichkeit sein "<strong>Würfel Stapel</strong>" zu treffen?<br /><i></i>',
	'CONF_SAVE_OKAY'		=> 'Die Konfiguration wurde aktualisiert.',
	'SCORE_DIFF_1'		=> 'Es fehlen Dir noch <b>%d</b> Punkte<br /> um den <b>%d</b>.Platz von %s<br />mit <b>%d</b> Punkten zu schlagen.<p style="text-align: center">%s</p>',
	'SCORE_DIFF_2'		=> 'Gratulation %s<br />Du bist mit <b>%s</b> Punkte<br /> auf dem <b>%d</b>.Platz diesen Monat.<p style="text-align: center">%s</p>',
	'SCORE_DIFF_3'		=> 'Es fehlen Dir noch <b>%d</b> Punkte<br /> um deinen eigenen Highscore<br />von <b>%d</b> Punkten<br /> und den <b>%d</b>.Platz zu schlagen.<br />%s',
	'SCORE_INFO'		=> 'geht an %s mit <b>%d</b> Punkten.<p style="text-align: center">%s</p>',
	'SCORE_DATE'		=> 'Erstellt',
	'SUM'				=> 'Summe',
	'END_SUM'			=> 'Endsumme',
	'TEIL_SUM'			=> 'Zwischensumme',
	'BONUS'			=> 'Bonus',
	'PUT_BONUS'			=> '<h3 style="color: red">Gratulation !</h3>Du bekommst <b>%d</b> Punkte als Bonus<h3></h3>',
	'PUT_NEXT_BONUS'		=> '<h3 style="color: red">Gratulation !</h3>Du bekommst <b>%d</b> zusäzliche Bonuspunkte<h3></h3>',
	'END_GAME'			=> '<h3 style="color: red">Gratulation !</h3>Du hast das Spiel mit <b>%s</b> Punkten beendet.<h3></h3>',
	'PLACE'			=> 'Platz',
	'RESTWURF'			=> 'Du hast noch 1 Wurf',
	'RESTWURFE'			=> 'Du hast noch %d Würfe',
	'EINTRAGEN'			=> 'Du hast schon 3mal gewürfelt. Du musst das Ergebnis eintragen.',
	'HOLD_TITLE'		=> 'diesen Würfel halten',
	'HOLD'			=> 'halten',
	'POINT'			=> 'Punkt',
	'POINTS'			=> 'Punkte',
	'GAMES'			=> 'Spiele',
	'TEXT'			=> 'Text',
	'RESET_GAME'		=> 'Spiel abbrechen',
	'NEW'				=> 'Neues Spiel beginnen',
	'SAFE_WURF'			=> '<h3>Eintrag gespeichert</h3>Eintrag wurde mit (<b>%d</b>) Punkte gespeichert',
	'KNIFFEL_EXTRA'		=> '<h3 style="color: red">SUPER KNIFFEL!</h3>Du bekommst <b>100</b> Punkte extra<h3></h3>',
	'BESCH_EINER'		=> '<b>Einer</b><br />Alle 1er zählen',
	'BESCH_ZWEIER'		=> '<b>Zweier</b><br />Alle 2er zählen',
	'BESCH_DREIER'		=> '<b>Dreier</b><br />Alle 3er zählen',
	'BESCH_VIERER'		=> '<b>Vierer</b><br />Alle 4er zählen',
	'BESCH_FUNFER'		=> '<b>Fünfer</b><br />Alle 5er zählen',
	'BESCH_SECHSER'		=> '<b>Sechser</b><br />Alle 6er zählen',
	'BESCH_DPASCH'		=> '<b>3er Pasch</b><br />3 gleiche Augen',
	'BESCH_VPASCH'		=> '<b>4er Pasch</b><br />4 gleiche Augen',
	'BESCH_FPASCH'		=> '<b>5er Pasch</b><br />5 gleiche Augen',
	'BESCH_DOPASCH'		=> '<b>Doppel Pasch</b><br />2x3 gleiche Augen',
	'BESCH_TRPASCH'		=> '<b>Triple Pasch</b><br />3x2 gleiche Augen',
	'BESCH_CRPASCH'		=> '<b>Crazy Pasch</b><br />1x1 und 1x2 und 1x3',
	'BESCH_GPASCH'		=> '<b>Gerader Pasch</b><br />alle geraden Augen',
	'BESCH_UPASCH'		=> '<b>Ungerader Pasch</b><br />alle ungeraden Augen',
	'BESCH_FULLH'		=> '<b>Full House</b><br />1x2 und 1x4 Augen',
	'BESCH_KSTRA'		=> '<b>kleine Strasse</b><br />Augen von 1-4<br />oder 2-5 oder 3-6 = 40 Punkte',
	'BESCH_GSTRA'		=> '<b>große Strasse</b><br />Augen von 2-6 | 1-5 = 50 Punkte',
	'BESCH_ALLEE'		=> '<b>Allee</b><br />Augen von 1-6 = 60 Punkte',
	'BESCH_KNIFFEL'		=> '<b>Super-Kniffel</b><br />6 gleiche Augen = 100 Punkte',
	'BESCH_CHANCE'		=> '<b>Chance</b><br />alle Augen zählen',
	'BONUS'			=> '35 bei 63<br />und 50 bei 85',
	'BESCHREIBUNG'		=> '<p>Wer kennt nicht das allseits beliebte Kniffel.<br />
			Dieses Spiel ist nun eine Abwandlung von Kniffel bzw. Yatzee.<br />
			Es ist im Prinzip das gleiche Spiel mit einigen Änderungen</p>
			<b>Allee</b><br />
			<b>5er Pasch</b><br />
			<b>Doppel Pasch</b><br />
			<b>Gerader Pasch</b><br />
			<b>Ungerader Pasch</b><br />
			<br />
			<p>Es werden 6 Würfel verwendet und es zählen grundsätzlich die Augen aller Würfel.<br />
			Ausnahmen:</p>
			<b>Allee = 60 Punkte</b><br />
			<b>Kniffel = 100 Punkte</b><br />
			<b>Kleiner Strasse = 40 Punkte</b><br />
			<b>Großer Strasse = 50 Punkte</b><br />
			<br />
			<p>Ziel ist es, soviel Punkte wie möglich zu bekommen.<br />
			Man hat 3 Würfe - über die Checkboxen oder Würfel werden die Würfel festgehalten.<br />
			Generell kann man jeden Wurf überall eintragen. Stimmen die Augen nicht, gibt es <b>0</b> Punkte.<br />
			<br />Beispiel:<br />
			Man würfelt: 3-3-1-6-4-2. Dies wäre z.B. eine Kleine Strasse (<b>40</b> Punkte).<br />
			Würde man diesen Wurf bei den ZWEIER eintragen, bekäme man nur <b>2</b> Punkte.</p>',
	'BESCHREIBUNG_VT'		=> '<p>Schabernack Funktion "<strong>Vom Tisch gefallen</strong>"<br /><img src="%1$svomtisch.gif"><br />
			Wenn dieser Würfel erscheint, warst du sehr ungeschickt. Du hast einen Würfel vom Tisch fallen lassen und musst nun die vorhandenen Würfel
			sofort eintragen!<br />
			Du wirst zu <strong>%2$d</strong> Prozent auf dieses Ereigniss treffen</p>',
	'BESCHREIBUNG_TR'		=> '<p>Schabernack Funktion "<strong>Würfel Stapel</strong>"<br /><img src="%1$sturm3.gif"><br />
			Sollte dieser Würfel erscheinen, musst du nochmal würfeln. Du erhälst einen Wurf mehr und kannst die verbleibenden Würfel halten.<br />
			Du wirst zu <strong>%2$d</strong> Prozent auf dieses Ereigniss treffen</p>',
));

?>